import mineflayer from 'mineflayer';

import { Main } from './controller/main.js';
import { Storage } from './controller/storage.js';

let {cfg} = await import('./config/'+process.argv[2]+'.js')


let i = process.argv[3]
let bots = {}
bots[cfg.acc[i].username] = {};
bots[cfg.acc[i].username].bot = mineflayer.createBot({
    host: "cbt.marin.rz.int",   // optional
    port: 25566,         // optional
    username: cfg.acc[i].username
})
bots[cfg.acc[i].username].task = cfg.acc[i].task;
bots[cfg.acc[i].username].data = cfg.acc[i].data;
bots[cfg.acc[i].username].events = cfg.acc[i].events;
bots[cfg.acc[i].username].main = new Main(bots[cfg.acc[i].username].bot);

Storage.bots = bots;

console.log(`Bot started as ${cfg.acc[i].username} with ${process.argv[2]}`)

