import Vec3 from "vec3";

export class distances{
    static distance = 0;
}

export function sortCoordinates(coordinates, referencePoint) {
    coordinates.sort((a, b) => {
        const distanceA = a.distanceTo(referencePoint);
        const distanceB = b.distanceTo(referencePoint);
        return distanceA - distanceB;
    });
    distances.distance += coordinates[0].distanceTo(referencePoint);
    return coordinates;
}

function distanceBetweenPoints(a, b) {
    const dx = a.x - b.x;
    const dy = a.y - b.y;
    const dz = a.z - b.z;
    return Math.sqrt(dx * dx + dy * dy + dz * dz);
}

export function getNearestCoordinate(coordinates, referencePoint) {
    return sortCoordinates(coordinates, referencePoint)[0];
}


export function sortTasksByDistance(arr) {
    for (let i = 0; i < arr.length; i++) {
        for (let j = 0; j < arr.length - i - 1; j++) {
            if (arr[j].priority > arr[j + 1].priority) {
                [arr[j], arr[j + 1]] = [arr[j + 1], arr[j]];
            }
        }
    }
    return arr;
}