import { Farmer } from "./modules/farmer/index.js"
import { WebView } from "./modules/viewer/index.js"
import { Storage } from "./storage.js"

import Path,{ pathfinder, Movements} from "mineflayer-pathfinder"
import Vec3 from "vec3";
import { TaskMgr } from "./taskmgr.js";
import findChests from "./helper/findChests.js";
import digBlock from "./modules/digBlock/index.js";


let me = null;
export class Main{
    loopCycle       = 40
    loops           = 0
    task            = null
    wa              = null
    nextPos         = []
    TaskMgr         = null
    constructor(bot){
        this.bot = bot;
        this.TaskMgr = new TaskMgr();
        me = this;
        bot.loadPlugin(pathfinder)
        bot.physicsEnabled = true;
        let farm = null ; 
        bot.on('spawn',()=>{
            const dM = new Movements(bot);
            bot.pathfinder.setMovements(dM)

            if(Storage.bots[bot.username].data != undefined){
                console.log(Storage.bots[bot.username].data)
                Storage.bots[bot.username].data.webView != undefined ? new WebView(bot,Storage.bots[bot.username].data.webView) : null;
            }
            for(let eventName in Storage.bots[bot.username].events){
                console.log(eventName);
                let e = Storage.bots[bot.username].events[eventName];
                console.log(e)
                bot.on(`${eventName}`,e)
            }
            
            //new WebView()
            //this.task = new Farmer();
            setTimeout(()=>{
                //findChests();
            },7000)
            
        })
        /*
            ADD EVENTS
        */

        bot.on('chat', (username, message) => {
            if (username === bot.username) return
            console.log(message)
            switch(username){
                default:
                    break;
            }
            //bot.chat(message)
        })
        bot.on('playerCollect',(collector,collected)=>{
            //console.log(collected)
        })
        bot.on(`itemDrop`,(entity)=>{
            //console.log(entity)
            
            /**
             * FARM
             */
            /*if(entity.metadata[8].itemId==991){
                let e = new Vec3(entity.position.x,entity.position.y,entity.position.z);
                let distance = e.distanceTo(Storage.bot.entity.position)
                console.log(distance)
                if(distance<=7){
                    this.nextPos.push(new Path.goals.GoalNear(
                        entity.position.x,
                        entity.position.y,
                        entity.position.z,
                        1
                    ));
                }
            }*/

        })
        bot.on('kicked',console.log);
        bot.on('error',console.log);
        bot.on('physicsTick',me.TickLoop)


    }
    async TickLoop(){
        let bot = me;
        bot.loops++;
        
        


        /**if(me.loopCycle<me.loops && me.nextPos.length == 0){
            console.log(`[LOOP] ${me.loops}`)
            if(me.task!=null){
                await me.task.loop()
            }
            me.loops = 0;
        }
        */
        if(bot.loops % 10 == 0){
            bot.bot.removeListener('physicsTick',bot.TickLoop)
            //console.log(Storage.bots[bot.bot.username].data)
            if(Storage.bots[bot.bot.username].task != undefined){
                await Storage.bots[bot.bot.username].task(bot.bot)
            }
            bot.bot.on('physicsTick',me.TickLoop);
            //await digBlock(this.bot,new Vec3(102,48,-2))
        }
        switch(bot.loops){
            case 10:
                
                break;
            default:

                break;
        }
        if(bot.loops > 80){
            //console.log(`[LOOP] ${bot.loops} - ${bot.nextPos}`)
            bot.loops = 0;
            //me.nextPos = null;
        }
       
    }
}
