import Vec3 from "vec3";
import {Storage} from '../../storage.js';

export default async function digBlock(bot, vec) {
  //console.log(`${bot.username} ${vec}`)
  
  vec == null ? vec = Storage.bots[bot.bot.username].data.pos : null
  const pos = bot.entity.position;
  const block = bot.blockAt(vec);
  if(block == null){ return false};
  if (block.name == "obsidian") {
    try {
      await bot.dig(block);
      console.log(`Successfully dug block at (${block.position.x}, ${block.position.y}, ${block.position.z})`);
      return true;
    } catch (err) {
      console.log(`Error digging block: ${err}`);
      return false;
    }
  } else {
    return false
  }
}