/**
 * Find & Kill Entity
 * @param {*} bot 
 * @returns 
 */
export default function killEntity(bot) {
    const filter = e => e.type === 'hostile' && e.position.distanceTo(bot.entity.position) < 5 &&
        e.mobType !== 'Armor Stand' // Mojang classifies armor stands as mobs for some reason?
    const entity = bot.nearestEntity(filter)

    if (entity) {
        bot.attack(entity)
    }

    return true;
}


let counter = {};
export function entityKilled(entity) {
    counter[entity.mobType] == undefined ? counter[entity.mobType] = 1: counter[entity.mobType]++
    console.log(`The bot killed an unknown ${entity.mobType}`);
    console.log(`Killed ${entity.mobType} -> ${counter[entity.mobType]}`)
}